/* OpenProcessing Tweak of *@*http://www.openprocessing.org/sketch/112419*@* */
/* !do not delete the line above, required for linking your tweak if you upload again */

import ddf.minim.*;

//These objects are resposible for telling our computer to play music
AudioPlayer bgmusicplayer;
Minim minim;

AudioPlayer itemCatchmusicplayer;
Minim itemminim;

//These are the fonts used to display the scores
PFont scorefont;
PFont pointsfont;

//This is a flag value that tells the game to display points when the player cathes a fruit
boolean pointsOn = false;

//This is the displayed points
int pointsValue;

//This says where to display the points and for how long (frame count)
int pointsx;
int pointsy;
int pointsFrameCount = 0;

//This is a timer object to control the game
Timer gametimer;

//This is how long the game will last

//Change this variable to make the game longer or shorter

/**********************************/
 
 //How can we change the variable gameDurationSeconds to make the game laster longer?

/**********************************/

int gameDurationSeconds = 30;

//This controls how many frames persecond our games draws in
int myFrameRate = 30;

//This contains the falling items or fruits
ArrayList items;

//this controls when fruits show appear or be spawned
int time;

//This is how fast the fruits are falling

int fruitspeed = 7;

//This variable will store our current socre
int score;

//This variable tells us if the game is done (True) or not (False)
boolean done;

//This is an image object for the game background
PImage backgroundimage;

//This is an image object for the fruit image
PImage fruitimage;

//This is a Player object
Player player;
//This is the player image
PImage playerimage;
//These booleans tell us if the player needs to move left or right
boolean moveplayerleft = false;
boolean moveplayerright = false;

void setup()
{
  scorefont = loadFont("Sansation-Bold-35.vlw");
  pointsfont = loadFont("Sansation-Bold-35.vlw");
  
  size(640,380);
  items = new ArrayList();
  
  /**********************************/
  
  //Edit the filenames here to change your player, background and fruit images
  
  /**********************************/
  
  playerimage = loadImage("playerimages/Luma.png");
  backgroundimage = loadImage("backgroundimages/spacebg.png");
  fruitimage = loadImage("fruitimages/starfruit.png");
  
  
  /**********************************/
  
  //Resize the fruit and player images to fit on the drawing canvas with a good aspect ratio
  
  /**********************************/
  
  //PUT SOME CODE HERE
  //PUT SOME CODE HERE
  fruitimage.resize(50,50);
  playerimage.resize(100,100);
  
  /**********************************/
  
  //Adjust where the player will be located on the drawing canvas here
  
  /**********************************/
  
  player = new Player(playerimage, width/2, height - 100);

  gametimer = new Timer(width - 200,60);
  
  minim = new Minim(this);
  
  /**********************************/
  
  //Edit the filename here to change your background music
  
  /**********************************/
  
  
  bgmusicplayer = minim.loadFile("backgroundmusic/Hyperbola.mp3", 2048);
  
  bgmusicplayer.play();
  
  itemminim = new Minim(this);
  
  /**********************************/
  
  //Edit the filename here to change your sound effect noise
  
  /**********************************/
  
  itemCatchmusicplayer = itemminim.loadFile("soundeffects/boip.mp3", 2048);
  
  gametimer.start();

}


void draw()
{
  background(backgroundimage);
  frameRate(myFrameRate);
  
  gametimer.DisplayTime(gameDurationSeconds);
  
  if(!done)
  {
    difficultyChange();
    spawn();
    
    /**********************************/
    
    //Call a "user defined" function here to make the fruit fall
    
    /**********************************/
    
    //PUT SOME CODE HERE
    moveFruit();
    
    drawWorld();

    checkEnd();
    
     /**********************************/
    
    //Call a "user defined" function here to check if we caught the fruit
    
    /**********************************/
    //put some code here
    checkCollision();
    
    fill(255);
    textFont(scorefont, 20);
    
    /**********************************/
    
    //Call a processing functions here to display the Score and Speed
    
    /**********************************/
    
    //PUT SOME CODE HERE
    //PUT SOME CODE HERE
    text("Score: " + score, 10,15);
    text("Speed: " + fruitspeed, 10,31);

    time++;
  }
  else
  {
    textFont(scorefont, 40);
    text("Good Job!",10,40);
    textFont(scorefont,20);
    text("SCORE: " + score,10,70);
    
  }

}

//Create the fruit
void spawn()
{
  if(time == myFrameRate / 2)
  {
    time = 0;
    Fruit aFruit = new Fruit(fruitimage, int(random(30,470)), fruitspeed, 3);
    
    //CHALLENGE1: Add a new type of fruit
    
    //CHALLENGE2: Add a powerup
    
    items.add(aFruit);
  }
}

//Make the fruit fall
void moveFruit()
{
  
  /**********************************/
  
  //Finish this for loop to make the fruits fall 
  
  /**********************************/
  
  
  for(int i = 0; i < items.size(); i++)
  {
    //inside the loop
    Fruit aFruit = (Fruit)items.get(i);
    aFruit.move();
  }
}

//Draw the game world
void drawWorld()
{
  for(int i = 0; i < items.size(); i++)
  {
    Fruit aFruit = (Fruit)items.get(i);
    aFruit.draw();
  }
  
  player.draw();
  
  if(moveplayerleft)
  {
    player.moveLeft();
  }
  
  if(moveplayerright)
  {
    player.moveRight();
  }

}

//Check if we caught the fruit
void checkCollision()
{
 
  for(int i = 0; i < items.size(); i++)
  {
    Fruit aFruit = (Fruit) items.get(i);
    
    if(player.Intersects(aFruit))
    {
      score += aFruit.value;
      pointsValue = aFruit.value;
      pointsx = aFruit.xlocation;
      pointsy = aFruit.ylocation;
      
      pointsOn = true;
      
      items.remove(i);
      aFruit = null;
      
      println("CAUGHT!");
      itemCatchmusicplayer.play();
      itemCatchmusicplayer.rewind();
      
      
    }
    
    displayPoints(pointsValue, pointsx, pointsy);
  }
}

//Function that will display points in the caught location
void displayPoints(int value, int x, int y)
{
  if(pointsOn && pointsFrameCount < 90)
  {
    textFont(pointsfont, 30);
    fill(255);
    text("+" + str(value), x, y);
    pointsFrameCount++;
  }
  else
  {
    pointsOn = false;
    pointsFrameCount = 0;
  }
}

void checkEnd()
{
    if(gametimer.currentTime() == gameDurationSeconds)
    {
      done = true;
      gametimer.pause();
    }
}

void difficultyChange()
{
  
  //Increase the difficulty every 5 seconds
  if(gametimer.currentTime() % 5 == 0 && gametimer.currentTime() != 0 && frameCount % myFrameRate == 0 && frameCount != 0)
  {
    fruitspeed++;
  }
  
}

void keyPressed(){

     if (key == CODED){
       
       /**********************************/
       
       //finish this conditional statement to make the player move left and right
       
       /**********************************/
       
       if(keyCode == LEFT)
       {
         moveplayerleft = true;
       }
       if(keyCode == RIGHT)
       {
         moveplayerright = true;
       }
    }
  
}

void keyReleased(){

    if (key == CODED){
      
      /**********************************/
      
       //finish this conditional statement to make the player move left and right
       
       /**********************************/
       
       if(keyCode == LEFT)
       {
         moveplayerleft = false;
       }
       if(keyCode == RIGHT)
       {
         moveplayerright = false;
       }
  }  
}


